package com.example.bluetooth.le;


import com.example.bluetooth.prt.HPRTHelper;
import com.example.bluetooth.prt.HPRTHelper.onDeviceName;
import com.example.bluetooth.prt.HPRTHelper.onDisconnect;
import com.example.bluetooth.prt.HPRTHelper.onElectricity;
import com.example.bluetooth.prt.HPRTHelper.onReaddeviceversion;
import com.example.bluetooth.prt.HPRTHelper.onWorkModel;

import android.app.Activity;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

public class MenuActivity extends Activity implements OnClickListener{
	private HPRTHelper mHelper;
	private TextView tv_version;
	private TextView tv_electricity;
	private TextView tv_work_model;
	private Context mContext;
	private int GATT=1;
	private int HID=2;
	private boolean isgetWork=false;
	private int WORK_MODEL=0;
	private TextView tv_voltage;
	private TextView tv_device_name;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_menu);
		mContext = getApplicationContext();
		init();
	}

	private void init() {
		tv_version = (TextView) findViewById(R.id.tv_version);
		tv_version.setOnClickListener(this);
		tv_electricity = (TextView) findViewById(R.id.tv_electricity);
		tv_electricity.setOnClickListener(this);
		tv_work_model = (TextView) findViewById(R.id.tv_work_model);
		tv_work_model.setOnClickListener(this);
		tv_voltage = (TextView) findViewById(R.id.tv_voltage);
		tv_voltage.setOnClickListener(this);
		tv_device_name = (TextView) findViewById(R.id.tv_devicename);
		tv_device_name.setOnClickListener(this);
		mHelper = HPRTHelper.getHPRTHelper(MenuActivity.this);
		initData();
	}

	private void initData() {
		readversion();
		getDeviceName();
		getPower();
		getWorkModel();
	}
	//ȡ豸
	private void getDeviceName(){
		mHelper.getDeviceName(new onDeviceName() {
			
			@Override
			public void succeed(byte[] data) {
				// TODO Auto-generated method stub
				tv_device_name.setText("豸ƣ"+Util.byteASCIIstr(data));
			}
			
			@Override
			public void failure() {
				// TODO Auto-generated method stub
				tv_device_name.setText("豸ƣȡ");
			}
		});
	}
	
	//ȡ汾
	private void readversion(){
		mHelper.setReaddeviceversion(new onReaddeviceversion() {
			
			@Override
			public void succeed(byte[] data) {
				// TODO Auto-generated method stub
				tv_version.setText("汾ţ"+data[data.length-1]+data[data.length-2]);
			}
			
			@Override
			public void failure() {
				// TODO Auto-generated method stub
				tv_version.setText("汾ţȡ");
			}
		});
	}
	private void getPower(){
		mHelper.getElectricity(new onElectricity() {
			
			@Override
			public void succeed(byte[] data) {
				// TODO Auto-generated method stub
				tv_electricity.setText(""+data[4]+"%");
				String parseHex =HPRTHelper.bytetohex(data[2])+HPRTHelper.bytetohex(data[3]);
				tv_voltage.setText("ѹ"+Integer.parseInt(parseHex.trim(),16)+"mV");
			}
			
			@Override
			public void failure() {
				// TODO Auto-generated method stub
				tv_electricity.setText("ȡ");
				tv_voltage.setText("ѹȡ");
			}
		});
	}
	private void getWorkModel(){
		mHelper.getWorkModel(new onWorkModel() {
			@Override
			public void succeed(byte[] data) {
				// TODO Auto-generated method stub
				if (data[2]==1) {
					tv_work_model.setText("ģʽGATT");
					WORK_MODEL=GATT;
					isgetWork=true;
				}else if(data[2]==2){
					tv_work_model.setText("ģʽHID");
					WORK_MODEL=HID;
					isgetWork=true;
				}else{
					tv_work_model.setText("ģʽȡ");
					isgetWork=false;
				}
			}
			@Override
			public void failure() {
				// TODO Auto-generated method stub
				tv_work_model.setText("ģʽȡ");
				isgetWork=false;
			}
		});
	}
	public void setting(View view){
		startActivity(new Intent(MenuActivity.this, SettingActivity.class));
	}
	public void workmodel(View view){
		if (isgetWork) {
			View contentView = LayoutInflater.from(mContext).inflate(
					R.layout.dialog_work_model, null);
			Builder builder = Util.DialogView(MenuActivity.this, contentView);
			final RadioGroup rg_work_model = (RadioGroup) contentView.findViewById(R.id.rg_work_model);
			switch (WORK_MODEL) {
			case 1:
				rg_work_model.check(R.id.rb_workmodel_gatt);
				break;
			case 2:
				rg_work_model.check(R.id.rb_workmodel_hid);
				break;
			default:
				break;
			}
			builder.setNegativeButton("ȷ", new DialogInterface.OnClickListener() {
				
				@Override
				public void onClick(DialogInterface dialog, int which) {
					// TODO Auto-generated method stub
					switch (rg_work_model.getCheckedRadioButtonId()) {
					case R.id.rb_workmodel_gatt:
						if(mHelper.setWorkModel(GATT)){
							Util.ToastMessage(mContext, "óɹ");
							finish();
						}else{
							Util.ToastMessage(mContext, "ʧ");
						}
						break;
					case R.id.rb_workmodel_hid:
						if(mHelper.setWorkModel(HID)){
							Util.ToastMessage(mContext, "óɹ");
							finish();
						}else{
							Util.ToastMessage(mContext, "ʧ");
						}
						break;

					default:
						break;
					}
				}
			});
			builder.setNeutralButton("ȡ", null);
			builder.show();
		}else {
			Util.ToastMessage(mContext, "ȡģʽʧܣ");
		}
	}
	public void scandata(View view){
		startActivity(new Intent(this, ScanDataActivity.class));
	}
	public void functions(View view){
		startActivity(new Intent(this, FunctionsActivity.class));
	}
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		if (mHelper!=null) {
    		mHelper.disconnect(new onDisconnect() {
				
				@Override
				public void succeed() {
					// TODO Auto-generated method stub
				}
			});
		}
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch (v.getId()) {
		case R.id.tv_version:
			if ("汾ţȡ".equals(tv_version.getText())) {
				readversion();
			}
			break;
		case R.id.tv_electricity:
			if ("ȡ".equals(tv_electricity.getText())) {
				getPower();
			}
			break;
		case R.id.tv_voltage:
			if ("ѹȡ".equals(tv_voltage.getText())) {
				getPower();
			}
			break;
		case R.id.tv_work_model:
			if ("ģʽȡ".equals(tv_work_model.getText())) {
				getWorkModel();
			}
			break;
		case R.id.tv_devicename:
			if ("豸ƣȡ".equals(tv_device_name.getText())) {
				getDeviceName();
			}
			break;

		default:
			break;
		}
	}
	public void deviceName(View view){
		View contentView = LayoutInflater.from(mContext).inflate(
				R.layout.dialog_device_name, null);
		Builder builder = Util.DialogView(MenuActivity.this, contentView);
		final EditText ed_device_name = (EditText) contentView.findViewById(R.id.ed_device_name);
		builder.setPositiveButton("ȷ", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				if(mHelper.setDeviceName(ed_device_name.getText().toString())){
					initData();
					Util.ToastMessage(mContext, "޸ĳɹ");
				}else{
					Util.ToastMessage(mContext, "޸ʧ");
				}
			}
		});
		builder.setNegativeButton("ȡ", null);
		builder.show();
	}
	public void Temporarily(View view){
		startActivity(new Intent(MenuActivity.this, TemporarilyActivity.class));
	}
}
